//+------------------------------------------------------------------+
//|                                                   MW Pattern.mq4 |
//|                                                            Shuba |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Shuba"
#property link      "http://www.metaquotes.net"

extern string _Parameters_Trend_ZZ = "-----     ZZ";
extern int       History=120;
extern int       Speed=6;
datetime LastBar = 0;           //  ,      
        

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  if(LastBar == Time[0])
    return(0);
  
  int W_UP, W_DW, W_UPDW, W_XZ, W_V, W_R;
  int M_UP, M_DW, M_DWUP, M_XZ, M_V, M_R;
   
   double ZZ0,ZZ1,ZZ2,ZZ3,ZZ4,ZZ5; //   
   int    x1, x2, x3, x4, x5; //   
   double arr[6] = {0,0};
   double xxx[6] = {0,0};
   int i=0, sh=0;
   while(sh<1000)
     {
     if(iCustom(NULL, 0, "ZigZag_AleksD",History,Speed, 0,sh)!=0)
       {
       arr[i]=iCustom(NULL, 0, "ZigZag_AleksD",History,Speed, 0,sh);
       xxx[i]=sh; 
       if(ZZ1 == 0) {ZZ1 = NormalizeDouble(arr[0],Digits); x1 = NormalizeDouble(xxx[0],Digits);}
       if(ZZ2 == 0) {ZZ2 = NormalizeDouble(arr[1],Digits); x2 = NormalizeDouble(xxx[1],Digits);}
       if(ZZ3 == 0) {ZZ3 = NormalizeDouble(arr[2],Digits); x3 = NormalizeDouble(xxx[2],Digits);}
       if(ZZ4 == 0) {ZZ4 = NormalizeDouble(arr[3],Digits); x4 = NormalizeDouble(xxx[3],Digits);}
       if(ZZ5 == 0) {ZZ5 = NormalizeDouble(arr[4],Digits); x5 = NormalizeDouble(xxx[4],Digits);} 
       
       i++;
       
       
 
//----  W -  ------------------------------+
 
     if(ZZ2 < ZZ1 && ZZ1 < ZZ4 && ZZ4 < ZZ3 && ZZ3 < ZZ5)
       {
       W_DW = 1; //  W1 
       Comment (" W1 - "); //     ZZ   
       Print (" W1 - ");
       // 2 1 4 3 5 -           
       }
     if(ZZ2 < ZZ4 && ZZ4 < ZZ1 && ZZ1 < ZZ3 && ZZ3 < ZZ5) 
       {
       W_DW = 1; //  W2 
       Comment (" W2 - "); //     ZZ   
       Print (" W2 - ");
       // 2 4 1 3 5
       }
     if(ZZ2 < ZZ4 && ZZ4 < ZZ3 && ZZ3 < ZZ1 && ZZ1 < ZZ5) 
       {
       W_XZ = 1; //  W3 
       Comment (" W3 - , ...");
       Print (" W3 - , ...");
       // 2 4 3 1 5 
       }
     if(ZZ4 < ZZ2 && ZZ2 < ZZ1 && ZZ1 < ZZ3 && ZZ3 < ZZ5) 
       {
       W_V = 1; //  W4 
       Comment (" W4 - ");
       Print (" W4 - ");
       // 4 2 1 3 5
       }
     if(ZZ4 < ZZ2 && ZZ2 < ZZ3 && ZZ3 < ZZ1 && ZZ1 < ZZ5) 
       {
       W_XZ = 1; //  W5 
       Comment (" W5 - , ...");
       Print (" W5 - , ...");
       // 4 2 3 1 5
       }
     if(ZZ2 < ZZ1 && ZZ1 < ZZ4 && ZZ4 < ZZ5 && ZZ5 < ZZ3)
       {
       W_UPDW = 1; //  W6     
       Comment (" W6 -     "); //     ZZ   
       Print (" W6 -     ");
       // 2 1 4 5 3 
       }
     if(ZZ2 < ZZ4 && ZZ4 < ZZ1 && ZZ1 < ZZ5 && ZZ5 < ZZ3)
       {
       W_UPDW = 1; //  W7     
       Comment (" W7 -     "); //     ZZ   
       Print (" W7 -     ");
       // 2 4 1 5 3
       }
     if(ZZ2 < ZZ4 && ZZ4 < ZZ3 && ZZ3 < ZZ5 && ZZ5 < ZZ1)
       {
       W_XZ = 1; //  W8 
       Comment (" W8 - , ...");
       Print (" W8 - , ...");
       // 2 4 3 5 1
       }
     if(ZZ4 < ZZ2 && ZZ2 < ZZ1 && ZZ1 < ZZ5 && ZZ5 < ZZ3)
       {
       W_UPDW = 1; //  W9     
       Comment (" W9 -     "); //     ZZ   
       Print (" W9 -     ");
       // 4 2 1 5 3
       }
     if(ZZ4 < ZZ2 && ZZ2 < ZZ3 && ZZ3 < ZZ5 && ZZ5 < ZZ1)
       {
       W_XZ = 1; //  W10 
       Comment (" W10 - , ...");
       Print (" W10 - , ...");
       // 4 2 3 5 1 
       }
     if(ZZ2 < ZZ4 && ZZ4 < ZZ5 && ZZ5 < ZZ1 && ZZ1 < ZZ3)
       {
       W_UPDW = 1; //  W11     
       Comment (" W11 -     "); //     ZZ   
       Print (" W11 -     ");
       // 2 4 5 1 3
       }       
     if(ZZ2 < ZZ4 && ZZ4 < ZZ5 && ZZ5 < ZZ3 && ZZ3 < ZZ1)
       {
       W_R = 1; //  W12 
       Comment (" W12 - ");
       Print (" W12 - ");
       // 2 4 5 3 1
       }       
     if(ZZ4 < ZZ2 && ZZ2 < ZZ5 && ZZ5 < ZZ1 && ZZ1 < ZZ3) 
       {
       W_UPDW = 1; //  W13     
       Comment (" W13 -     "); //     ZZ   
       Print (" W13 -     ");
       // 4 2 5 1 3
       }       
     if(ZZ4 < ZZ2 && ZZ2 < ZZ5 && ZZ5 < ZZ3 && ZZ3 < ZZ1)
       {
       W_UP = 1; //  W14 
       Comment (" W14 - "); //     ZZ   
       Print (" W14 - ");
       // 4 2 5 3 1
       }
     if(ZZ4 < ZZ5 && ZZ5 < ZZ2 && ZZ2 < ZZ1 && ZZ1 < ZZ3) 
       {
       W_UPDW = 1; //  W15     
       Comment (" W15 -     "); //     ZZ   
       Print (" W15 -     ");
       // 4 5 2 1 3
       }
     if(ZZ4 < ZZ5 && ZZ5 < ZZ2 && ZZ2 < ZZ3 && ZZ3 < ZZ1)
       {
       W_UP = 1; //  W16 
       Comment (" W16 - "); //     ZZ   
       Print (" W16 - ");
       // 4 5 2 3 1
       }
       
 //----  M -  ------------------------------+
   
       if(ZZ1 < ZZ3 && ZZ3 < ZZ2 && ZZ2 < ZZ5 && ZZ5 < ZZ4)
         {
         M_DW = 1; //  M1 
         Comment (" M1 - "); //     ZZ   
         Print (" M1 - ");
         // 1 3 2 5 4
         }
       if(ZZ3 < ZZ1 && ZZ1 < ZZ2 && ZZ2 < ZZ5 && ZZ5 < ZZ4)
         {
         M_DWUP = 1; //  M2      
         Comment (" M2 -      "); //     ZZ   
         Print (" M2 -      ");
         // 3 1 2 5 4
         }
       if(ZZ1 < ZZ3 && ZZ3 < ZZ5 && ZZ5 < ZZ2 && ZZ2 < ZZ4)
         {
         M_DW = 1; //  M3 
         Comment (" M3 - "); //     ZZ   
         Print (" M3 - ");
         // 1 3 5 2 4
         }
       if(ZZ3 < ZZ1 && ZZ1 < ZZ5 && ZZ5 < ZZ2 && ZZ2 < ZZ4)
         {
         M_DWUP = 1; //  M4      
         Comment (" M4 -      "); //     ZZ   
         Print (" M4 -      ");
         // 3 1 5 2 4
         }
       if(ZZ1 < ZZ3 && ZZ3 < ZZ5 && ZZ5 < ZZ4 && ZZ4 < ZZ2)
         {
         M_R = 1; //  M5 
         Comment (" M5 - ");
         Print (" M5 - ");
         // 1 3 5 4 2
         }
       if(ZZ3 < ZZ1 && ZZ1 < ZZ5 && ZZ5 < ZZ4 && ZZ4 < ZZ2)
         {
         M_DWUP = 1; //  M6      
         Comment (" M6 -      "); //     ZZ   
         Print (" M6 -      ");
         // 3 1 5 4 2
         }
       if(ZZ1 < ZZ5 && ZZ5 < ZZ3 && ZZ3 < ZZ2 && ZZ2 < ZZ4)
         {
         M_XZ = 1; //  M7 
         Comment (" M7 - , ...");
         Print (" M7 - , ...");
         // 1 5 3 2 4
         }
       if(ZZ3 < ZZ5 && ZZ5 < ZZ1 && ZZ1 < ZZ2 && ZZ2 < ZZ4)
         {
         M_DWUP = 1; //  M8      
         Comment (" M8 -      "); //     ZZ   
         Print (" M8 -      ");
         // 3 5 1 2 4
         }
       if(ZZ1 < ZZ5 && ZZ5 < ZZ3 && ZZ3 < ZZ4 && ZZ4 < ZZ2)
         {
         M_XZ = 1; //  M9 
         Comment (" M9 - , ...");
         Print (" M9 - , ...");
         // 1 5 3 4 2
         }
       if(ZZ3 < ZZ5 && ZZ5 < ZZ1 && ZZ1 < ZZ4 && ZZ4 < ZZ2)
         {
         M_DWUP = 1; //  M10      
         Comment (" M10 -      "); //     ZZ   
         Print (" M10 -      ");
         // 3 5 1 4 2 
         }
       if(ZZ3 < ZZ5 && ZZ5 < ZZ4 && ZZ4 < ZZ1 && ZZ1 < ZZ2)
         {
         M_DWUP  = 1; //  M11      
         Comment (" M11 -      "); //     ZZ   
         Print (" M11 -      ");
         // 3 5 4 1 2
         }
       if(ZZ5 < ZZ1 && ZZ1 < ZZ3 && ZZ3 < ZZ2 && ZZ2 < ZZ4)
         {
         M_XZ = 1; //  M12 
         Comment (" M12 - , ...");
         Print (" M12 - , ...");
         // 5 1 3 2 4
         }
       if(ZZ5 < ZZ3 && ZZ3 < ZZ1 && ZZ1 < ZZ2 && ZZ2 < ZZ4)
         {
         M_V = 1; //  M13 
         Comment (" M13 - ");
         Print (" M13 - ");
         // 5 3 1 2 4
         }
       if(ZZ5 < ZZ1 && ZZ1 < ZZ3 && ZZ3 < ZZ4 && ZZ4 < ZZ2)
         {
         M_XZ = 1; //  M14 
         Comment (" M14 - , ...");
         Print (" M14 - , ...");
         // 5 1 3 4 2
         }
       if(ZZ5 < ZZ3 && ZZ3 < ZZ1 && ZZ1 < ZZ4 && ZZ4 < ZZ2)
         {
         M_UP = 1; //  M15 
         Comment (" M15 - "); //     ZZ   
         Print (" M15 - ");
         // 5 3 1 4 2 
         }
       if(ZZ5 < ZZ3 && ZZ3 < ZZ4 && ZZ4 < ZZ1 && ZZ1 < ZZ2)
         {
         M_UP = 1; //  M16 
         Comment (" M16 "); //     ZZ   
         Print (" M16 ");
         // 5 3 4 1 2
         }
     
       }
     if(i==6) return(0);                  
     sh++;
     }  
    
      
//----
  LastBar = Time[0];
//----
   return(0);
  }
//+------------------------------------------------------------------+

